''' <summary>
''' Extends document with PSI-specific information and methods
''' </summary>
Partial Public Class PsiDocument_V2

    Private _offensesCollection As OffensesCollection


    Public Sub New()    'required for deserialization
        _offensesCollection = New OffensesCollection()
        Dim off As Offense
        Dim offdet As OffenseDetail
        For i As Integer = 0 To 5
            off = New Offense() With {.ArrestDate = DateTime.Now, .DocketNumber = ((i + 1) * 11111).ToString()}
            If i > 0 Then
                For j As Integer = 1 To 2
                    offdet = New OffenseDetail() With {.OffenseAsConvicted = "Going 'Commando'.", .OffenseAsCharged = "Speeding without a vehicle.", .StatutesAndPenalties = "The Secret Standards or Military Toughness."}
                    off.AddDetail(offdet)
                Next
            End If
            _offensesCollection.Add(off)
        Next
    End Sub

    'collections
    Public ReadOnly Property OffensesCollection() As BindingList(Of Offense)
        Get
            Return _offensesCollection
        End Get
        'Set(ByVal value As ObservableCollection(Of Long))
        '    _documentAttachments = value
        '    IsDirty = True
        'End Set
    End Property

    Public Function AddOffense(ByVal position As Integer, ByVal off As Offense) As Boolean 'Implements IPsiDocument.AddOffense
        Try
            _offensesCollection.Insert(position, off)
            Return True
        Catch ex As Exception
            Throw New Exception("Error adding attachment: " + ex.Message)
        End Try
    End Function

End Class
